#!/usr/bin/perl
# colorlogs.pl - A PERL script to colorize log viewing

#Edit if you move the config file from the default location
$configfile='/usr/local/sbin/colorlogs.conf';


### DO NOT EDIT ANYTHING BELOW HERE ###

# Check for the existance of the configfile
if ( ! -e $configfile ) {
	print "ERROR: an error occoured while opening the config file \"$configfile\"\n";
} else {
	# Readin the config file and set stuff up
        open (CFG, $configfile);
		NEXTLINE:
		$line=<CFG>;
                chomp $line;
		while( defined($line) ) {
			if ($line =~ /:/) {
				goto NEXTLINE;
			} else {
				($color,$string) = split/,/,$line;
				$color=lc($color);
				$config{$string} = "$color";
				$line=<CFG>;
	        	        chomp $line;
			} # if ... else
		} # while
        close(CFG);
	
	# Init the Assoc Array (AKA HASH)
	%config;
	
	# Detect what color the logfile line should be and 
	# convert color from text to ANSI color code
	while ( defined($line=<>) ) {
		foreach $string ( sort keys %config ) {   
                	$rawcolor= lc($config{$string});
			if ($line =~ /$string/ ) {
				if ( $rawcolor eq "red") {
					$txtcolor="\033[31m";
                                } elsif ( $rawcolor eq "green") {
                                        $txtcolor="\033[32m";
                                } elsif ( $rawcolor eq "yellow") {
                                        $txtcolor="\033[33m";
                                } elsif ( $rawcolor eq "blue") {
                                        $txtcolor="\033[34m";
                                } elsif ( $rawcolor eq "purple") {
                                        $txtcolor="\033[35m";
                                } elsif ( $rawcolor eq "cyan") {
                                        $txtcolor="\033[36m";
                                } elsif ( $rawcolor eq "white") {
                                        $txtcolor="\033[37m";
                                } else {
					$txtcolor="\033[0m";
				} # if ... elsif ... else

				# Print the line in the proper color and
				# return to the default text color
				print "$txtcolor$line\033[0m";
			} # if
        	} # foreach 
	} # while
} # if ... else
